package com.ether.dao;

import com.ether.PersistenceException;
import com.ether.tapas.Observatory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

/**
 * @author vmipsl
 * @date may 2011
 * Example for a DAO
 */
public class ObservatoryDAOImpl
        extends DomainAccessObjectImpl<Observatory, Integer>
        implements ObservatoryDAO
{
    protected ObservatoryDAOImpl()
    {
        super( Observatory.class );
    }

//    @Nullable
//    public Observatory getPlateformById( @NotNull final Integer plateformId )
//            throws PersistenceException
//    {
//        final DetachedCriteria criteria = DetachedCriteria.forClass( Plateform.class )
//                .add( Restrictions.idEq( plateformId ) );
//
//        return selectByCriteria( Plateform.class, criteria );
//    }


    @NotNull
    public List<Observatory> getAllObservatories()
            throws PersistenceException
    {
        final DetachedCriteria criteria = DetachedCriteria.forClass( Observatory.class )
            //.add( (Criterion) Order.asc( "name" ) );
            .addOrder( Order.asc( "name" ) );
        return selectAllByCriteria( Observatory.class, criteria );
    }

    @Nullable
    public Observatory getObservatoryById( @NotNull final long id)
            throws PersistenceException
    {
        final DetachedCriteria criteria = DetachedCriteria.forClass( Observatory.class )
                    .add( Restrictions.eq( "id", id ));
        return selectByCriteria( Observatory.class, criteria );
    }

    @Nullable
    public Observatory getObservatoryByName( @NotNull final String name)
            throws PersistenceException
    {
        final DetachedCriteria criteria = DetachedCriteria.forClass( Observatory.class )
                    .add( Restrictions.eq( "name", name ));
        return selectByCriteria( Observatory.class, criteria );
    }
}