package com.ether;

import com.ether.tapas.Observatory;
import com.ether.tapas.Tapas;
import com.ether.tapas.TapasRequest;
import com.ether.user.User;
import org.jdom.Document;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Properties;

/**
 * @author rboipsl
 * @date 02 march 2012
 */
public interface TapasService
        extends BackofficeService
{

    public void createXMLRequest( @NotNull final Tapas tapas, @NotNull final Properties prop )
            throws ServiceException;

    public void createUserFtpDir( @NotNull final User user, @NotNull final Properties prop )
            throws ServiceException;

    public void createXMLFile( final Document document, final String commandePath, final Properties prop );

    public List<Observatory> getAllObservatories() throws ServiceException;

    public Observatory getObservatoryById(@NotNull final long id) throws ServiceException;

    public Observatory getObservatoryByName(@NotNull final String name) throws ServiceException;

    public Long getNumRequest() throws ServiceException;

    public String createFileName(String date, String type, String shortName) throws ServiceException;

    public boolean execAppelQSub( final String commandePath, @NotNull final User user, @NotNull final Properties prop ) throws ServiceException;

    Long insertTapasRequest( @NotNull User user ) throws ServiceException;

}
